Index: src/view/SpecTrackV.cpp
===================================================================
--- src/view/SpecTrackV.cpp	(revision 0)
+++ src/view/SpecTrackV.cpp	(working copy)
@@ -0,0 +1,875 @@
+#include "../Audacity.h"
+#include "../TrackArtist.h"
+#include "float_cast.h"
+
+SpecTrackV::SpecTrackV(void): 
+WaveTrackV()
+{
+}
+
+SpecTrackV::~SpecTrackV(void)
+{
+}
+
+void SpecTrackV::DrawSpectrum(wxEvtHandler *win,
+                               WaveTrack *track,
+                               wxDC & dc,
+                               const wxRect & r,
+                               const ViewInfo *viewInfo,
+                               bool autocorrelation,
+                               bool logF)
+{
+   DrawBackgroundWithSelection(&dc, r, track, blankSelectedBrush, blankBrush,
+         viewInfo->sel0, viewInfo->sel1, viewInfo->h, viewInfo->zoom);
+
+   if(!viewInfo->bUpdateTrackIndicator && viewInfo->bIsPlaying) {
+      // BG: Draw (undecorated) waveform instead of spectrum
+      DrawWaveform(track, dc, r, viewInfo, false, false, false, false, false);
+      return;
+   }
+
+   for (WaveClipList::compatibility_iterator it = track->GetClipIterator(); it; it = it->GetNext()) {
+      DrawClipSpectrum(win, track, it->GetData(), dc, r, viewInfo, autocorrelation, logF);
+   }
+}
+
+#ifdef EXPERIMENTAL_DRAW_THREAD
+
+class DrawClipSpectrumThread: public wxThread
+{
+public:
+   TrackArtist *ta;
+   WaveTrack *track;
+   WaveClip *clip;
+   wxDC &dc;
+   const wxRect &r;
+   const ViewInfo *viewInfo;
+   bool autocorrelation;
+   bool logF;
+   wxImage *image;
+   wxRect mid;
+   wxEvtHandler *win;
+
+   DrawClipSpectrumThread(wxEvtHandler *win_,
+                          TrackArtist *ta_,
+                          WaveTrack *track_,
+                          WaveClip *clip_,
+                          wxDC & dc_,
+                          const wxRect & r_,
+                          const ViewInfo *viewInfo_,
+                          bool autocorrelation_,
+                          bool logF_,
+                          wxImage *image_,
+                          wxRect mid_):
+		wxThread(), ta(ta_), track(track_), clip(clip_), dc(dc_), r(r_), 
+      viewInfo(viewInfo_), autocorrelation(autocorrelation_), logF(logF_),
+      image(image_), mid(mid_), win(win_)
+      {}
+
+   virtual ExitCode Entry()
+	{	track->inUpdate++;
+      ta->DrawClipSpectrumReal(win, track, clip, dc, r, viewInfo, 
+         autocorrelation, logF, image, mid);
+      track->inUpdate--;
+      return 0;
+	}
+};
+#endif //EXPERIMENTAL_DRAW_THREAD
+
+void SpecTrackV::DrawClipSpectrum(wxEvtHandler *win,
+                                   WaveTrack *track,
+                                   WaveClip *clip,
+                                   wxDC & dc,
+                                   const wxRect & r,
+                                   const ViewInfo *viewInfo,
+                                   bool autocorrelation,
+                                   bool logF)
+{
+#ifdef EXPERIMENTAL_DRAW_THREAD
+   if (track->inUpdate > 0)
+      return;
+
+   double h = viewInfo->h;
+   double pps = viewInfo->zoom;
+   double sel0 = viewInfo->sel0;
+   double sel1 = viewInfo->sel1;
+
+   double tOffset = clip->GetOffset();
+   double rate = clip->GetRate();
+   double sps = 1./rate;
+
+   int range = gPrefs->Read(wxT("/Spectrum/Range"), 80L);
+   int gain = gPrefs->Read(wxT("/Spectrum/Gain"), 20L);
+
+   if (!track->GetSelected())
+      sel0 = sel1 = 0.0;
+
+   double tpre = h - tOffset;
+   double tstep = 1.0 / pps;
+   double tpost = tpre + (r.width * tstep);
+   double trackLen = clip->GetEndTime() - clip->GetStartTime();
+
+   bool showIndividualSamples = (pps / rate > 0.5);   //zoomed in a lot
+   double t0 = (tpre >= 0.0 ? tpre : 0.0);
+   double t1 = (tpost < trackLen - sps*.99 ? tpost : trackLen - sps*.99);
+   if(showIndividualSamples) t1+=2./pps; // for display consistency
+   // with Waveform display
+
+   // Make sure t1 (the right bound) is greater than 0
+   if (t1 < 0.0)
+      t1 = 0.0;
+
+   // Make sure t1 is greater than t0
+   if (t0 > t1)
+      t0 = t1;
+
+   sampleCount ssel0 = wxMax(0, sampleCount((sel0 - tOffset) * rate + .99));
+   sampleCount ssel1 = wxMax(0, sampleCount((sel1 - tOffset) * rate + .99));
+
+   //trim selection so that it only contains the actual samples
+   if (ssel0 != ssel1 && ssel1 > (sampleCount)(0.5+trackLen*rate))
+      ssel1 = (sampleCount)(0.5+trackLen*rate);
+
+   // The variable "mid" will be the rectangle containing the
+   // actual waveform, as opposed to any blank area before
+   // or after the track.
+   wxRect mid = r;
+
+   dc.SetPen(*wxTRANSPARENT_PEN);
+
+   // If the left edge of the track is to the right of the left
+   // edge of the display, then there's some blank area to the
+   // left of the track.  Reduce the "mid"
+   // rect by size of the blank area.
+   if (tpre < 0) {
+      // Fill in the area to the left of the track
+      wxRect pre = r;
+      if (t0 < tpost)
+         pre.width = (int) ((t0 - tpre) * pps);
+
+      // Offset the rectangle containing the waveform by the width
+      // of the area we just erased.
+      mid.x += pre.width;
+      mid.width -= pre.width;
+   }
+
+   // If the right edge of the track is to the left of the the right
+   // edge of the display, then there's some blank area to the right
+   // of the track.  Reduce the "mid" rect by the
+   // size of the blank area.
+   if (tpost > t1) {
+      wxRect post = r;
+      if (t1 > tpre)
+         post.x += (int) ((t1 - tpre) * pps);
+      post.width = r.width - (post.x - r.x);
+
+      // Reduce the rectangle containing the waveform by the width
+      // of the area we just erased.
+      mid.width -= post.width;
+   }
+
+   // The "mid" rect contains the part of the display actually
+   // containing the waveform.  If it's empty, we're done.
+   if (mid.width <= 0) {
+#if PROFILE_WAVEFORM
+#   ifdef __WXMSW__
+      _time64(&tv1);
+      double elapsed = _difftime64(tv1, tv0);
+#   else
+      gettimeofday(&tv1, NULL);
+      double elapsed =
+         (tv1.tv_sec + tv1.tv_usec*0.000001) -
+         (tv0.tv_sec + tv0.tv_usec*0.000001);
+#   endif
+      gWaveformTimeTotal += elapsed;
+      gWaveformTimeCount++;
+#endif
+      return;
+   }
+
+   // We draw directly to a bit image in memory,
+   // and then paint this directly to our offscreen
+   // bitmap.  Note that this could be optimized even
+   // more, but for now this is not bad.  -dmazzoni
+   wxImage *image = new wxImage((int) mid.width, (int) mid.height);
+   if (!image)return;
+
+   DrawClipSpectrumThread *the=new DrawClipSpectrumThread(win, this, 
+      track, clip, dc, r, viewInfo, autocorrelation, logF,
+      image, mid);
+   the->Create(0x100000);
+   the->Run();
+}
+
+void SpecTrackV::DrawClipSpectrumReal(wxEvtHandler *win,
+                                       WaveTrack *track,
+                                       WaveClip *clip,
+                                       wxDC & dc,
+                                       const wxRect & r,
+                                       const ViewInfo *viewInfo,
+                                       bool autocorrelation,
+                                       bool logF,
+                                       wxImage *image,
+                                       wxRect mid)
+{
+#endif //EXPERIMENTAL_DRAW_THREAD
+
+#if PROFILE_WAVEFORM
+#  ifdef __WXMSW__
+   __time64_t tv0, tv1;
+   _time64(&tv0);
+#  else
+   struct timeval tv0, tv1;
+   gettimeofday(&tv0, NULL);
+#  endif
+#endif
+   double h = viewInfo->h;
+   double pps = viewInfo->zoom;
+   double sel0 = viewInfo->sel0;
+   double sel1 = viewInfo->sel1;
+
+   double tOffset = clip->GetOffset();
+   double rate = clip->GetRate();
+   double sps = 1./rate;
+
+   if (!track->GetSelected())
+      sel0 = sel1 = 0.0;
+
+   double tpre = h - tOffset;
+   double tstep = 1.0 / pps;
+   double tpost = tpre + (r.width * tstep);
+   double trackLen = clip->GetEndTime() - clip->GetStartTime();
+
+   bool showIndividualSamples = (pps / rate > 0.5);   //zoomed in a lot
+   double t0 = (tpre >= 0.0 ? tpre : 0.0);
+   double t1 = (tpost < trackLen - sps*.99 ? tpost : trackLen - sps*.99);
+   if(showIndividualSamples) t1+=2./pps; // for display consistency
+   // with Waveform display
+
+   // Make sure t1 (the right bound) is greater than 0
+   if (t1 < 0.0)
+      t1 = 0.0;
+
+   // Make sure t1 is greater than t0
+   if (t0 > t1)
+      t0 = t1;
+
+   sampleCount ssel0 = wxMax(0, sampleCount((sel0 - tOffset) * rate + .99));
+   sampleCount ssel1 = wxMax(0, sampleCount((sel1 - tOffset) * rate + .99));
+
+   //trim selection so that it only contains the actual samples
+   if (ssel0 != ssel1 && ssel1 > (sampleCount)(0.5+trackLen*rate))
+      ssel1 = (sampleCount)(0.5+trackLen*rate);
+
+#ifdef EXPERIMENTAL_DRAW_THREAD
+#else //!EXPERIMENTAL_DRAW_THREAD
+   // The variable "mid" will be the rectangle containing the
+   // actual waveform, as opposed to any blank area before
+   // or after the track.
+   wxRect mid = r;
+
+   dc.SetPen(*wxTRANSPARENT_PEN);
+
+   // If the left edge of the track is to the right of the left
+   // edge of the display, then there's some blank area to the
+   // left of the track.  Reduce the "mid"
+   // rect by size of the blank area.
+   if (tpre < 0) {
+      // Fill in the area to the left of the track
+      wxRect pre = r;
+      if (t0 < tpost)
+         pre.width = (int) ((t0 - tpre) * pps);
+
+      // Offset the rectangle containing the waveform by the width
+      // of the area we just erased.
+      mid.x += pre.width;
+      mid.width -= pre.width;
+   }
+
+   // If the right edge of the track is to the left of the the right
+   // edge of the display, then there's some blank area to the right
+   // of the track.  Reduce the "mid" rect by the
+   // size of the blank area.
+   if (tpost > t1) {
+      wxRect post = r;
+      if (t1 > tpre)
+         post.x += (int) ((t1 - tpre) * pps);
+      post.width = r.width - (post.x - r.x);
+
+      // Reduce the rectangle containing the waveform by the width
+      // of the area we just erased.
+      mid.width -= post.width;
+   }
+
+   // The "mid" rect contains the part of the display actually
+   // containing the waveform.  If it's empty, we're done.
+   if (mid.width <= 0) {
+#if PROFILE_WAVEFORM
+#   ifdef __WXMSW__
+      _time64(&tv1);
+      double elapsed = _difftime64(tv1, tv0);
+#   else
+      gettimeofday(&tv1, NULL);
+      double elapsed =
+         (tv1.tv_sec + tv1.tv_usec*0.000001) -
+         (tv0.tv_sec + tv0.tv_usec*0.000001);
+#   endif
+      gWaveformTimeTotal += elapsed;
+      gWaveformTimeCount++;
+#endif
+      return;
+   }
+
+   // We draw directly to a bit image in memory,
+   // and then paint this directly to our offscreen
+   // bitmap.  Note that this could be optimized even
+   // more, but for now this is not bad.  -dmazzoni
+   wxImage *image = new wxImage((int) mid.width, (int) mid.height);
+   if (!image)return;
+#endif //EXPERIMENTAL_DRAW_THREAD
+
+   unsigned char *data = image->GetData();
+
+   int windowSize = GetSpectrumWindowSize();
+
+   int half = windowSize/2;
+   float *freq = new float[mid.width * half];
+   sampleCount *where = new sampleCount[mid.width+1];
+
+   bool updated = clip->GetSpectrogram(freq, where, mid.width,
+                              t0, pps, autocorrelation);
+   int ifreq = lrint(rate/2);
+
+   int maxFreq;
+   if (!logF)
+      maxFreq = vrulerv->GetSpectrumMaxFreq(ifreq);
+   else
+      maxFreq = vrulerv->GetSpectrumLogMaxFreq(ifreq);
+   if(maxFreq > ifreq)
+      maxFreq = ifreq;
+
+   int minFreq;
+   if (!logF) {
+      minFreq = vrulerv->GetSpectrumMinFreq(0);
+      if(minFreq < 0)
+         minFreq = 0;
+   }
+   else {
+      minFreq = vrulerv->GetSpectrumLogMinFreq(ifreq/1000.0);
+      if(minFreq < 1)
+         minFreq = ifreq/1000.0;
+   }
+
+   int range=vrulerv->mRange;
+   int gain=vrulerv->mGain;
+
+   bool usePxCache = false;
+
+   if( !updated && clip->GetSpecPxCache()->valid && (clip->GetSpecPxCache()->len == mid.height * mid.width) 
+#ifdef EXPERIMENTAL_FFT_Y_GRID
+   && mFftYGrid==mFftYGridOld
+#endif //EXPERIMENTAL_FFT_Y_GRID
+#ifdef EXPERIMENTAL_FIND_NOTES
+   && mFftFindNotes==mFftFindNotesOld
+   && mFindNotesMinA==mFindNotesMinAOld
+   && mNumberOfMaxima==mFindNotesNOld
+   && mFindNotesQuantize==mFindNotesQuantizeOld
+#endif
+   ) {
+      usePxCache = true;
+   }
+   else {
+      clip->SetSpecPxCache(new SpecPxCache(mid.width * mid.height));
+
+      usePxCache = false;
+      clip->GetSpecPxCache()->valid = true;
+#ifdef EXPERIMENTAL_FIND_NOTES
+      mFftFindNotesOld=mFftFindNotes;
+      mFindNotesMinAOld=mFindNotesMinA;
+      mFindNotesNOld=mNumberOfMaxima;
+      mFindNotesQuantizeOld=mFindNotesQuantize;
+#endif
+   }
+
+   int minSamples = int ((double)minFreq * (double)windowSize / rate + 0.5);   // units are fft bins
+   int maxSamples = int ((double)maxFreq * (double)windowSize / rate + 0.5);
+   int temp = sizeof(int);
+   float binPerPx = float(maxSamples - minSamples) / float(mid.height);
+
+   int x = 0;
+   sampleCount w1 = (sampleCount) ((t0*rate + x *rate *tstep) + .5);
+ 
+   const float 
+//      e=exp(1.0f), 
+      f=rate/2.0f/half, 
+      lmin=logf(float(minFreq)),
+      lmax=logf(float(maxFreq)),
+#ifdef EXPERIMENTAL_FIND_NOTES
+      log2=logf(2.0f),
+#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
+      lmins=logf(float(minFreq)/(vrulerv->mFftSkipPoints+1)),
+      lmaxs=logf(float(maxFreq)/(vrulerv->mFftSkipPoints+1)),
+#else //!EXPERIMENTAL_FFT_SKIP_POINTS
+      lmins=lmin,
+      lmaxs=lmax,
+#endif //EXPERIMENTAL_FFT_SKIP_POINTS
+#endif //EXPERIMENTAL_FIND_NOTES
+      scale=lmax-lmin /*, 
+      expo=exp(scale)*/ ;
+
+#ifdef EXPERIMENTAL_FFT_Y_GRID
+   const float
+      scale2=(lmax-lmin)/log2,
+      lmin2=lmin/log2;
+
+   bool *yGrid;
+   yGrid=new bool[mid.height];
+   for (int y = 0; y < mid.height; y++) {
+      float n =(float(y  )/mid.height*scale2-lmin2)*12; 
+      float n2=(float(y+1)/mid.height*scale2-lmin2)*12; 
+#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
+      float f =float(minFreq)/(vrulerv->mFftSkipPoints+1)*powf(2.0f, n /12.0f+lmin2);
+      float f2=float(minFreq)/(vrulerv->mFftSkipPoints+1)*powf(2.0f, n2/12.0f+lmin2);
+#else //!EXPERIMENTAL_FFT_SKIP_POINTS
+      float f =float(minFreq)*powf(2.0f, n /12.0f+lmin2);
+      float f2=float(minFreq)*powf(2.0f, n2/12.0f+lmin2);
+#endif //EXPERIMENTAL_FFT_SKIP_POINTS
+      n =logf(f /440)/log2*12;
+      n2=logf(f2/440)/log2*12;
+      if (floor(n) < floor(n2))
+         yGrid[y]=true;
+      else
+         yGrid[y]=false;
+   }
+#endif //EXPERIMENTAL_FFT_Y_GRID
+
+#ifdef EXPERIMENTAL_FIND_NOTES
+   int maxima[128];
+   float maxima0[128], maxima1[128];
+   const int MAX_NOTES=10;
+   float 
+      notes  [MAX_NOTES], 
+      starts [MAX_NOTES], 
+      levels [MAX_NOTES], 
+      lengths[MAX_NOTES];
+   for (int n=0; n<MAX_NOTES; n++)
+   {  notes[n]=0;
+      starts[n]=0;
+      levels[n]=0;
+      lengths[n]=0;
+   }
+   const float 
+#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
+      f2bin = half/(rate/2.0f/(vrulerv->mFftSkipPoints+1)),
+#else //!EXPERIMENTAL_FFT_SKIP_POINTS
+      f2bin = half/(rate/2.0f),
+#endif //EXPERIMENTAL_FFT_SKIP_POINTS
+      bin2f = 1.0f/f2bin,
+      minDistance = powf(2.0f, 2.0f/12.0f),
+      i0=expf(lmin)/f,
+      i1=expf(scale+lmin)/f,
+      minColor=0.0f;
+   const int maxTableSize=1024;
+   int *indexes=new int[maxTableSize];
+
+   float rainbow_r[2][7], rainbow_g[2][7], rainbow_b[2][7];
+   for (int si=0; si<2; si++) {  
+      for (int hi=0; hi<7; hi++) {  
+         float h=hi/7.0f;
+         float s=1-float(si)/2;
+         hsb2rgb(h,s,1, rainbow_r[si][hi], rainbow_g[si][hi], rainbow_b[si][hi]);
+         rainbow_r[si][hi]*=255;
+         rainbow_g[si][hi]*=255;
+         rainbow_b[si][hi]*=255;
+      }
+   }
+#endif //EXPERIMENTAL_FIND_NOTES
+
+   while (x < mid.width) 
+   {
+      sampleCount w0 = w1;
+      w1 = (sampleCount) ((t0*rate + (x+1) *rate *tstep) + .5);
+      if (!logF)
+      {
+         for (int yy = 0; yy < mid.height; yy++) {
+            bool selflag = (ssel0 <= w0 && w1 < ssel1);
+            unsigned char rv, gv, bv;
+            float value;
+
+            if(!usePxCache) {
+               float bin0 = float (yy) * binPerPx + minSamples;
+               float bin1 = float (yy + 1) * binPerPx + minSamples;
+
+
+               if (int (bin1) == int (bin0))
+                  value = freq[half * x + int (bin0)];
+               else {
+                  float binwidth= bin1 - bin0;
+                  value = freq[half * x + int (bin0)] * (1.f - bin0 + (int)bin0);
+
+                  bin0 = 1 + int (bin0);
+                  while (bin0 < int (bin1)) {
+                     value += freq[half * x + int (bin0)];
+                     bin0 += 1.0;
+                  }
+
+                  // Do not reference past end of freq array.
+                  if (int(bin1) >= half) {
+                     bin1 -= 1.0;
+                  }
+
+                  value += freq[half * x + int (bin1)] * (bin1 - int (bin1));
+
+                  value /= binwidth;
+               }
+
+               if (!autocorrelation) {
+                  // Last step converts dB to a 0.0-1.0 range
+                  value = (value + range + gain) / (double)range;
+               }
+
+               if (value > 1.0)
+                  value = float(1.0);
+               if (value < 0.0)
+                  value = float(0.0);
+               clip->GetSpecPxCache()->values[x * mid.height + yy] = value;
+            }
+            else
+               value = clip->GetSpecPxCache()->values[x * mid.height + yy];
+
+            GetColorGradient(value, selflag, mIsGrayscale, &rv, &gv, &bv);
+
+            int px = ((mid.height - 1 - yy) * mid.width + x) * 3;
+            data[px++] = rv;
+            data[px++] = gv;
+            data[px] = bv;
+         }
+      }
+      else //logF
+      {
+         bool selflag = (ssel0 <= w0 && w1 < ssel1);
+         unsigned char rv, gv, bv;
+         float value;
+         int x0=x*half;
+
+#ifdef EXPERIMENTAL_FIND_NOTES
+         int maximas=0;
+         if (!usePxCache && mFftFindNotes) {
+            for (int i = maxTableSize-1; i >= 0; i--)
+               indexes[i]=-1;
+            
+            // Build a table of (most) values, put the index in it.
+            for (int i = int(i0); i < int(i1); i++) {
+               float freqi=freq[x0+int(i)];
+               int value=int((freqi+gain+range)/range*(maxTableSize-1));
+               if (value < 0)
+                  value=0;
+               if (value >= maxTableSize)
+                  value=maxTableSize-1;
+               indexes[value]=i;
+            }
+            // Build from the indices an array of maxima.
+            for (int i = maxTableSize-1; i >= 0; i--) {
+               int index=indexes[i];
+               if (index >= 0) {
+                  float freqi=freq[x0+index];
+                  if (freqi < mFindNotesMinA) 
+                     break;
+
+                  bool ok=true;
+                  for (int m=0; m < maximas; m++) {
+                     // Avoid to store very close maxima.
+                     float maxm = maxima[m];
+                     if (maxm/index < minDistance && index/maxm < minDistance) {
+                        ok=false;
+                        break;
+                     }
+                  }
+                  if (ok) {
+                     maxima[maximas++] = index;
+                     if (maximas >= mNumberOfMaxima)
+                        break;
+                  }
+               }
+            }
+
+// The f2pix helper macro converts a frequency into a pixel coordinate.
+#define f2pix(f) (logf(f)-lmins)/(lmaxs-lmins)*mid.height
+
+// The pix2f helper macro converts a pixel coordinate into a frequency.
+#define pix2f(pix) expf(float(pix)/mid.height*(lmaxs-lmins)+lmins)
+
+            // Possibly quantize the maxima frequencies and create the pixel block limits.
+            for (int i=0; i < maximas; i++) {
+               int index=maxima[i];
+               float f = float(index)*bin2f;
+               if (mFindNotesQuantize)
+               {  float note=int(log(f/440)/log2*12)-0.5f;
+                  f = expf(note/12.0f*log2)*440;
+                  maxima[i] = f*f2bin;
+                  float delta=1000;
+                  int nn=-1;
+                  for (int n=0; n<mNumberOfMaxima; n++)
+                  {  if (levels[n] < 0.01f)
+                     {  delta=abs(notes[n]-note);
+                        nn=n;
+                     }
+                     if (abs(notes[n]-note) < delta)
+                     {  delta=abs(notes[n]-note);
+                        nn=n;
+                     }
+                  }
+                  if (nn >= 0)
+                  {  if (levels[nn] < 0.01f)
+                        starts[nn]=x;
+                     notes[nn]=note;
+                     value = (freq[index] + gain + range) / (double)range;
+                     levels[nn]=(levels[nn]*2+value)/3;
+                     lengths[nn]=x-starts[nn];
+                     //if (lengths[nn] > 10)
+                     {  float f0 = expf((log(f/440)/log2*12-0.5f-levels[nn]/2)/12.0f*log2)*440;
+                        maxima0[i] = f2pix(f0);
+                        float f1 = expf((log(f/440)/log2*12)/12.0f*log2)*440;
+                        maxima1[i] = f2pix(f1);
+                     }
+                  }
+                  for (int n=0; n<mNumberOfMaxima; n++)
+                  {  levels[n]*=0.99f;
+                     if (levels[n] < 0.01f)
+                     {  starts[n]=x;
+                        lengths[n]=x-starts[n];
+                     }
+                  }
+               }else
+               {  float f0 = expf((log(f/440)/log2*12-1)/12.0f*log2)*440;
+                  maxima0[i] = f2pix(f0);
+                  float f1 = expf((log(f/440)/log2*12)/12.0f*log2)*440;
+                  maxima1[i] = f2pix(f1);
+               }
+            }
+         }
+         int it=0;
+         int oldBin0=-1;
+         bool inMaximum = false;
+#endif //EXPERIMENTAL_FIND_NOTES
+
+         double yy2_base=exp(lmin)/f;
+         float yy2 = yy2_base;
+         double exp_scale_per_height = exp(scale/mid.height);
+         for (int yy = 0; yy < mid.height; yy++) {
+            if(!usePxCache) {
+               if (int(yy2)>=half)
+                  yy2=half-1;
+               if (yy2<0)
+                  yy2=0;
+               float bin0 = float(yy2);
+               yy2_base *= exp_scale_per_height;
+               float yy3 = yy2_base;
+               if (int(yy3)>=half)
+                  yy3=half-1;
+               if (yy3<0)
+                  yy3=0;
+               float bin1 = float(yy3);
+
+#ifdef EXPERIMENTAL_FIND_NOTES
+               if (mFftFindNotes) {
+                  if (it < maximas) {
+                     float i0=maxima0[it];
+                     if (yy >= i0)
+                        inMaximum = true;
+
+                     if (inMaximum) {
+                        float i1=maxima1[it];
+                        if (yy+1 <= i1) {
+                           value=sumFreqValues(freq, x0, bin0, bin1);
+                           if (!mFindNotesQuantize && value < mFindNotesMinA)
+                              value = minColor;
+                           else
+                              value = (value + gain + range) / (double)range;
+                        } else {
+                           it++;
+                           inMaximum = false;
+                           value = minColor;
+                        }
+                     } else {
+                        value = minColor;
+                     }
+                  } else
+                     value = minColor;
+               } else
+#endif //EXPERIMENTAL_FIND_NOTES
+               {
+                  value=sumFreqValues(freq, x0, bin0, bin1);
+                  if (!autocorrelation) {
+                     // Last step converts dB to a 0.0-1.0 range
+                     value = (value + gain + range) / (double)range;
+                  }
+               }
+               if (value > 1.0)
+                  value = float(1.0);
+               if (value < 0.0)
+                  value = float(0.0);
+               clip->GetSpecPxCache()->values[x * mid.height + yy] = value;
+               yy2 = yy2_base;
+            }
+            else
+               value = clip->GetSpecPxCache()->values[x * mid.height + yy];
+
+
+#ifdef EXPERIMENTAL_FIND_NOTES
+            if (mIsGrayscale && mFftFindNotes) {
+               float f = pix2f(yy);
+               float note = logf(f/440.0f)/log2*12+0.5f+1200;
+               int inote = int(fmodf(note, 12.0f));
+               if (inote < 0) 
+                  inote+=12;
+               int scale[14]={0,0,1,2,2,3,3,4,5,5,6,6,7,7};
+               int scsat[14]={0,1,0,0,1,0,1,0,0,1,0,1,0,1};
+               int scaled=scale[inote];
+               int sat   =scsat[inote];
+               float grey=float(value)*float(value);
+	            rv=grey*rainbow_r[sat][scaled];
+	            gv=grey*rainbow_g[sat][scaled];
+	            bv=grey*rainbow_b[sat][scaled];
+            }
+            else
+#endif //EXPERIMENTAL_FIND_NOTES
+            {  GetColorGradient(value, selflag, mIsGrayscale, &rv, &gv, &bv);
+            }
+
+#ifdef EXPERIMENTAL_FFT_Y_GRID
+            if (mFftYGrid && yGrid[yy]) {
+               if (mIsGrayscale) {
+                  rv += 20; rv = rv>255? 255:rv;
+                  gv += 20; gv = gv>255? 255:gv;
+                  bv += 20; bv = bv>255? 255:bv;
+               } else {
+                  rv /= 1.1f;
+                  gv /= 1.1f;
+                  bv /= 1.1f;
+               }
+            }
+#endif //EXPERIMENTAL_FFT_Y_GRID
+
+            int px = ((mid.height - 1 - yy) * mid.width + x) * 3;
+            data[px++] = rv;
+            data[px++] = gv;
+            data[px] = bv;
+         }
+      }
+      x++;
+   }
+
+#ifdef EXPERIMENTAL_DRAW_THREAD
+   TrackUpdateData *udata=new TrackUpdateData;
+   udata->mid=mid;
+   udata->image=image;
+   udata->clip=clip;
+   wxCommandEvent ev(wxEVT_COMMAND_BUTTON_CLICKED, OnUpdateAfterThreadRunID);
+   ev.SetEventObject(win);
+   ev.SetClientData(udata);
+   win->AddPendingEvent(ev);
+#else //!EXPERIMENTAL_DRAW_THREAD
+   // If we get to this point, the clip is actually visible on the
+   // screen, so remember the display rectangle.
+   clip->SetDisplayRect(mid);
+
+   wxBitmap converted = wxBitmap(*image);
+
+   wxMemoryDC memDC;
+
+   memDC.SelectObject(converted);
+
+   dc.Blit(mid.x, mid.y, mid.width, mid.height, &memDC, 0, 0, wxCOPY, FALSE);
+
+   delete image;
+#endif //EXPERIMENTAL_DRAW_THREAD
+
+   delete[] where;
+   delete[] freq;
+
+#ifdef EXPERIMENTAL_FFT_Y_GRID
+   delete[] yGrid;
+#endif //EXPERIMENTAL_FFT_Y_GRID
+
+#ifdef EXPERIMENTAL_FIND_NOTES
+   delete[] indexes;
+#endif //EXPERIMENTAL_FIND_NOTES
+}
+
+void SpecTrackV::InvalidateSpectrumCache(TrackList *tracks)
+{
+   TrackListOfKindIterator iter(Track::Wave, tracks);
+   for (Track *t = iter.First(); t; t = iter.Next()) {
+      InvalidateSpectrumCache((WaveTrack *)t);
+   }
+}
+
+void SpecTrackV::InvalidateSpectrumCache(WaveTrack *track)
+{
+   WaveClipList::compatibility_iterator it;
+   for (it = track->GetClipIterator(); it; it = it->GetNext()) {
+      it->GetData()->GetSpecPxCache()->valid = false;
+   }
+}
+
+float SpecTrackV::sumFreqValues(float *freq, int x0, float bin0, float bin1)
+{
+   float value;
+   if (int(bin1) == int(bin0)) {
+      value = freq[x0+int(bin0)];
+   } else {
+      float binwidth= bin1 - bin0;
+      value = freq[x0 + int(bin0)] * (1.f - bin0 + (int)bin0);
+
+      bin0 = 1 + int (bin0);
+      while (bin0 < int(bin1)) {
+         value += freq[x0 + int(bin0)];
+         bin0 += 1.0;
+      }
+      value += freq[x0 + int(bin1)] * (bin1 - int(bin1));
+      value /= binwidth;
+   }
+   return value;
+}
+
+// (Hue,Saturation,Brightness) to (R,G,B):
+//
+// Hue: [0..1] {0: red, 0.33: green, 0.66: blue, 1: red}
+// Saturation: [0..1] {0: no color, 1: full color}
+// Brightness: [0..1] {0: black, 1: brightest}
+void SpecTrackV::hsb2rgb(float h, float s, float b_, float &r, float &g, float &b)
+{
+	float h2,L,x,y,z;
+	h=fmodf(h,1.0f)*3;
+	h2=fmodf(h,1.0f);
+	if (h2 < 0.5)
+	{	L=b_*(1+s*h2);
+		s=s/(1+s*h2);	//s>=0, h2>=0 always so never s/0
+		x=1+(-1-h2)*s;	y=1-h2*s;	z=1-(1-h2)*s;
+	}else
+	{	L=b_*(1+s*(1-h2));
+		s=s/(1+s*(1-h2));
+		y=1-h2*s;	z=1-(1-h2)*s;	x=1-(2-h2)*s;
+	}
+	x=x*L; 	y=y*L;	z=z*L;
+	if (h < 1.0)
+	{	b=x; r=y; g=z;
+	}else	if (h < 2.0)
+	{	r=x;	g=y;	b=z;
+	}else
+	{	g=x;	b=y;	r=z;
+	}
+	if (r < 0) r=0;
+	if (g < 0) g=0;
+	if (b < 0) b=0;
+	if (r > 1) r=1;
+	if (g > 1) g=1;
+	if (b > 1) b=1;
+}
+
+// Get various preference values
+int SpecTrackV::GetSpectrumWindowSize()
+{
+   return mFFTSize;
+}
Index: src/view/SpecTrackV.h
===================================================================
--- src/view/SpecTrackV.h	(revision 0)
+++ src/view/SpecTrackV.h	(working copy)
@@ -0,0 +1,50 @@
+
+class AUDACITY_DLL_API SpecTrackV:
+virtual public WaveTrackV
+{
+public:
+   SpecTrackV(void);
+   ~SpecTrackV(void);
+
+   void DrawSpectrum(wxEvtHandler *win, WaveTrack *track,
+                     wxDC & dc, const wxRect & r, const ViewInfo *viewInfo,
+                     bool autocorrelation, bool logF);
+
+   void DrawClipSpectrum(wxEvtHandler *win, WaveTrack *track, WaveClip *clip,
+                         wxDC & dc, const wxRect & r, const ViewInfo *viewInfo,
+                         bool autocorrelation, bool logF);
+
+#ifdef EXPERIMENTAL_DRAW_THREAD
+   void DrawClipSpectrumReal(wxEvtHandler *win, WaveTrack *track, WaveClip *clip,
+                             wxDC & dc, const wxRect & r, const ViewInfo *viewInfo,
+                             bool autocorrelation, bool logF, 
+                             wxImage *image, wxRect mid);
+#endif //EXPERIMENTAL_DRAW_THREAD
+
+   void InvalidateSpectrumCache(TrackList *tracks);
+   void InvalidateSpectrumCache(WaveTrack *track);
+
+   float sumFreqValues(float *freq, int x0, float bin0, float bin1);
+
+   void hsb2rgb(float h, float s, float b_, float &r, float &g, float &b);
+
+   int GetSpectrumWindowSize();
+
+   // Preference values
+#ifdef EXPERIMENTAL_FFT_Y_GRID
+   bool mFftYGrid;            // "/Spectrum/FFTYGrid"
+   bool mFftYGridOld;
+#endif //EXPERIMENTAL_FFT_Y_GRID
+
+#ifdef EXPERIMENTAL_FIND_NOTES
+   bool mFftFindNotes;        // "/Spectrum/FFTFindNotes"
+   bool mFftFindNotesOld;
+   float mFindNotesMinA;      // "/Spectrum/FindNotesMinA"
+   int mFindNotesMinAOld;
+   int mFindNotesNOld;
+   int mNumberOfMaxima;       // "/Spectrum/FindNotesN"
+   bool mFindNotesQuantize;   // "/Spectrum/FindNotesQuantize")
+   bool mFindNotesQuantizeOld;
+   int mFFTSize;           // "/Spectrum/FFTSize"
+#endif //EXPERIMENTAL_FIND_NOTES
+};
Index: src/view/TimeTrackV.cpp
===================================================================
--- src/view/TimeTrackV.cpp	(revision 0)
+++ src/view/TimeTrackV.cpp	(working copy)
@@ -0,0 +1,24 @@
+#include "../Audacity.h"
+#include "../TrackArtist.h"
+
+TimeTrackV::TimeTrackV(void):
+TrackV()
+{
+}
+
+TimeTrackV::~TimeTrackV(void)
+{
+}
+
+void TimeTrackV::DrawTimeTrack(TimeTrack *track,
+                                wxDC & dc,
+                                const wxRect & r,
+                                const ViewInfo *viewInfo)
+{
+   track->Draw(dc, r, viewInfo->h, viewInfo->zoom);
+   wxRect envRect = r;
+   envRect.height -= 2;
+   track->GetEnvelope()->DrawPoints(dc, envRect, viewInfo->h, viewInfo->zoom, 
+               false,0.0,1.0);
+}
+
